stages:
  - build

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: ['']
  before_script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/warmer --cache-dir=$CI_PROJECT_DIR/.cache_images --image=node:14-alpine
    - echo TAG1 "${CI_COMMIT_REF_SLUG}"
    - echo TAG2 "${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHA}"
  script:
    - /kaniko/executor
      --cache-dir=$CI_PROJECT_DIR/.cache_images
      --context ${CI_PROJECT_DIR}
      --dockerfile ${CI_PROJECT_DIR}/Dockerfile
      --destination ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
      --destination ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHA}
      --destination ${CI_REGISTRY_IMAGE}:latest
      --build-arg NPM_TOKEN=${NPM_TOKEN}
      --single-snapshot
  only:
    - master
